import { ChangeDetectorRef, DoCheck, ElementRef, EventEmitter, IterableDiffers, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { AbstractControl, ControlValueAccessor, FormControl, Validator } from '@angular/forms';
import { Observable, Subject } from 'rxjs';
import { MultiSelectSearchFilter } from './search-filter.pipe';
import { IMultiSelectOption, IMultiSelectSettings, IMultiSelectTexts } from './types';
import * as i0 from "@angular/core";
export declare class MultiselectDropdownComponent implements OnInit, OnChanges, DoCheck, OnDestroy, ControlValueAccessor, Validator {
    private element;
    private searchFilter;
    private cdRef;
    filterControl: FormControl<string>;
    options: IMultiSelectOption[];
    settings: IMultiSelectSettings;
    texts: IMultiSelectTexts;
    disabled: boolean;
    disabledSelection: boolean;
    searchFunction: (str: string) => RegExp;
    selectionLimitReached: EventEmitter<any>;
    dropdownClosed: EventEmitter<any>;
    dropdownOpened: EventEmitter<any>;
    onAdded: EventEmitter<any>;
    onRemoved: EventEmitter<any>;
    onLazyLoad: EventEmitter<any>;
    onFilter: Observable<string>;
    get focusBack(): boolean;
    clickedOutside(): void;
    destroyed$: Subject<void>;
    filteredOptions: IMultiSelectOption[];
    lazyLoadOptions: IMultiSelectOption[];
    renderFilteredOptions: IMultiSelectOption[];
    model: any[];
    prevModel: any[];
    parents: any[];
    title: string;
    differ: any;
    numSelected: number;
    set isVisible(val: boolean);
    get isVisible(): boolean;
    renderItems: boolean;
    checkAllSearchRegister: Set<unknown>;
    checkAllStatus: boolean;
    loadedValueIds: any[];
    _focusBack: boolean;
    focusedItem: IMultiSelectOption | undefined;
    showDividerAfterCheck: boolean;
    defaultSettings: IMultiSelectSettings;
    defaultTexts: IMultiSelectTexts;
    get searchLimit(): number;
    get searchRenderAfter(): number;
    get searchLimitApplied(): boolean;
    private _isVisible;
    private _workerDocClicked;
    constructor(element: ElementRef, searchFilter: MultiSelectSearchFilter, differs: IterableDiffers, cdRef: ChangeDetectorRef);
    getItemStyle(option: IMultiSelectOption): any;
    getItemStyleSelectionDisabled(): any;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    updateRenderItems(): void;
    applyFilters(options: any, value: any): IMultiSelectOption[];
    fireModelChange(): void;
    onModelChange: Function;
    onModelTouched: Function;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    setDisabledState(isDisabled: boolean): void;
    ngDoCheck(): void;
    validate(_c: AbstractControl): Record<string, any>;
    registerOnValidatorChange(_fn: () => void): void;
    clearSearch(event: Event): void;
    toggleDropdown(e?: Event): void;
    closeDropdown(e?: Event): void;
    isSelected(option: IMultiSelectOption): boolean;
    setSelected(_event: Event, option: IMultiSelectOption): void;
    updateNumSelected(): void;
    updateTitle(): void;
    searchFilterApplied(): boolean;
    addChecks(options: any): void;
    checkAll(): void;
    uncheckAll(): void;
    preventCheckboxCheck(event: Event, option: IMultiSelectOption): void;
    isCheckboxDisabled(option?: IMultiSelectOption): boolean;
    checkScrollPosition(ev: any): void;
    checkScrollPropagation(ev: any, element: any): void;
    trackById(idx: number, selectOption: IMultiSelectOption): any;
    load(): void;
    focusItem(dir: number, e?: Event): void;
    private maybePreventDefault;
    private maybeStopPropagation;
    private _escapeRegExp;
    static ɵfac: i0.ɵɵFactoryDeclaration<MultiselectDropdownComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MultiselectDropdownComponent, "ss-multiselect-dropdown", never, { "options": { "alias": "options"; "required": false; }; "settings": { "alias": "settings"; "required": false; }; "texts": { "alias": "texts"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "disabledSelection": { "alias": "disabledSelection"; "required": false; }; "searchFunction": { "alias": "searchFunction"; "required": false; }; }, { "selectionLimitReached": "selectionLimitReached"; "dropdownClosed": "dropdownClosed"; "dropdownOpened": "dropdownOpened"; "onAdded": "onAdded"; "onRemoved": "onRemoved"; "onLazyLoad": "onLazyLoad"; "onFilter": "onFilter"; }, never, never, true, never>;
}
